/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) <year>  <name of author>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/

#include "kmconf.h"
#include "qdebug.h"
#include "qapplication.h"

KmConf::KmConf( KmTail *pKmTail, Qt::WindowFlags f ): 
	QDialog(pKmTail, f),
	Ui::KmConf()
{
	setupUi( this );
	mpKmTail = pKmTail;
	mCBList << mpDebugCB << mpInfoCB << mpNoticeCB << mpWarningCB << mpErrCB << mpCritCB << mpAlertCB << mpEmergCB;
	mLEList << mpDebugLE << mpInfoLE << mpNoticeLE << mpWarningLE << mpErrLE << mpCritLE << mpAlertLE << mpEmergLE;
	
	for ( int k = KmTail::DEBUG; k <= KmTail::EMERG; ++k )
	{
		mCBList[k]->setColor( mpKmTail->mPriCols[k] );
		mLEList[k]->setText( mpKmTail->mTags[k].join( "," ) );
	}		

	mpTstmpCB->setColor( pKmTail->mTstmpCol );
	
	if ( pKmTail->mUsrFont )
		mpFontSel->setFont( pKmTail->mFont );
		
	QPushButton *pBtn = mpBtnBox->button( QDialogButtonBox::Reset );
	pBtn->setText( i18n("&Defaults") );
}

void KmConf::btnClicked( QAbstractButton *btn )
{
	QString tag;
	QStringList tagList;
	
	if ( mpBtnBox->buttonRole( btn ) == QDialogButtonBox::AcceptRole )
	{
		for ( int k = KmTail::DEBUG; k <= KmTail::EMERG; ++k )
		{
			mpKmTail->mPriCols[k] = mCBList[k]->color().name();
			tagList = mLEList[k]->text().split( ",",  QString::SkipEmptyParts );
			if ( !tagList.isEmpty() )
				mpKmTail->mTags[k] = tagList;
			else
				mpKmTail->mTags[k] = QStringList();
		}		

		mpKmTail->mTstmpCol = mpTstmpCB->color().name();
		
		if ( !(mpKmTail->mFont == mpFontSel->font()) )
		{
			mpKmTail->mFont = mpFontSel->font();
			mpKmTail->mUsrFont = true;
		}
		
		accept();
	}	
	else if ( mpBtnBox->buttonRole( btn ) == QDialogButtonBox::ResetRole )
	{
		for ( int k = KmTail::DEBUG; k <= KmTail::EMERG; ++k )
		{
			mCBList[k]->setColor( mpKmTail->mDefPriCols[k] );
			tag = mpKmTail->mDefTags[k].join( "," );
			if ( tag.isNull() )
				mLEList[k]->clear();
			else
				mLEList[k]->setText( tag );
			
			mpKmTail->mPriCols[k] = mpKmTail->mDefPriCols[k];
			mpKmTail->mTags.replace( k, mpKmTail->mDefTags[k] ); 
		}		

		mpTstmpCB->setColor( TSTMP_COL );									// light blue
		
		mpFontSel->setFont( QApplication::font() ); 
	}	
	else if ( mpBtnBox->buttonRole( btn ) == QDialogButtonBox::RejectRole )
	{
		reject();
	}
}

